package jvpc.blitz;

import java.io.*;
import java.net.*;

import kero.awt.*;

import jvpc.vga.*;

public class BlitzThread extends Thread {
    String gamename;
    int race;
    InputFileOpener ifo;
    MySocket socket;
    Persistent persistent;

    public BlitzThread(MySocket socket, String gamename, int race,
		       InputFileOpener ifo, Blitz blitz)
	throws IOException
    {
	System.err.println("creating BlitzThread...");
	this.socket = socket;
	this.gamename = gamename;
	this.race = race;
	this.ifo = ifo;

	persistent = new Persistent(socket, gamename, race, ifo, blitz.adapter);
	// annoying = new Annoying(socket, gamename, race, ifo);
	blitz.dispose();
    }

    public void run() {
	while (true) {
	    try {
		String str = socket.gets();
		System.err.println(str);
		StreamTokenizer tokenizer = new StreamTokenizer(
		    new StringReader(str));
		tokenizer.nextToken();
		String command = tokenizer.sval;
		if ("end".equals(command)) {
		    System.exit(0);
		} else if ("host".equals(command)) {
		  tokenizer.nextToken();
		  int time_until = (int)tokenizer.nval;
		  if (time_until > 0) {
		      // call some interface method for the ajoined client
		      // for now, we know Annoying is the stand-alone :)
		      persistent.remaining = time_until;
		      if (time_until <= 30) {
			  persistent.show();
			  //annoying.warning.setText("Hosting in "+time_until+" seconds!");
			  //annoying.pack();
			  //annoying.show();
		      }
		  }
		} else if ("msg".equals(command)) {
		    persistent.setMessage(str);
		    System.out.println(str);
		} else if ("turn".equals(command)) {
		    tokenizer.nextToken();
		    persistent.setTurnNumber((int)tokenizer.nval);
		} else if ("ping".equals(command)) {
		    socket.write("pong");
		} else if ("file".equals(command)) {
		    System.err.println("Receiving file...");
		    tokenizer.nextToken();
		    String name = tokenizer.sval;
		    System.err.println("file: "+name);
		    tokenizer.nextToken();
		    int size = (int)tokenizer.nval;
		    System.err.println("of size: "+size);
		    byte[] rst = new byte[size];
		    int offset = 0;
		    while (offset != size) {
			int result = socket.getInputStream().read(rst, offset, size-offset);
			System.err.println("result: "+result);
			if (result >= 0) offset += result;
		    }
		    File f = new File(ifo.getWorkDir()+File.separator+name);
		    FileOutputStream fos = new FileOutputStream(f);
		    fos.write(rst);
		    fos.close();
		    persistent.setMessage("Received file "+name);
		} else if ("OK".equals(command)) {
		    // OK!
		    String bla = "OK  Game "+gamename+" joined as race ";
		    if (str.indexOf(bla) == 0) {
			race = Integer.parseInt(str.substring(bla.length(), str.length()));
			System.out.println("Found race: "+race);
		    }
		    persistent.setMessage(str.replace(';', '\n'));
		} else if ("ERROR".equals(command)) {
		    // error :(
		    System.err.println(" ==> "+command+" <== ");
		} else {
		    System.err.println("Unknown command "+str+" received");
		}
	    } catch (IOException ioe) {
		System.err.println(ioe);
	    }
	}
    }
}
