package jvpc.extdata;

import java.util.*;
import java.io.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * Simple class for the purpose of reading and writing the Markers (and possibly
 * other data int he future) from resp. to File.
 *
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 25 III 2001
 * @version 25 III 2001
 */
public class DataBase extends Reporter {
    protected static String fileName = "jvpc-ext.dat";
    Vector marker = new Vector();

    public void addMarker(Marker m) {
	marker.addElement(m);
    }

    public void removeMarker(Marker m) {
	marker.removeElement(m);
    }

    public void writeExtData(OutputFileOpener ofo) {
	System.err.println("DataBase.writeExtData()");
	FileOutputStream stream = ofo.open(fileName);
	if (stream == null) crash(1001, "Can not open file "+fileName);
	FileWriter writer;
	try {
	    writer = new FileWriter(stream.getFD());
	} catch (IOException _) {
	    crash(101, "Could not change stream into writer");
	    return; // silence compiler
	}

	Enumeration enum = marker.elements();
	while (enum.hasMoreElements()) {
	    Marker m = (Marker)enum.nextElement();
	    String s = "Marker = "+m.getX()+", "+m.getY()+", \""+m.getText()+"\"";
	    try {
		writer.write(s, 0, s.length());
	    } catch (IOException ioe) {
		warn("Could not write extdata ("+s+") to File "+fileName);
	    }
	}
	try {
	    writer.close();
	} catch (IOException _) {}
    }

}
