// File: BaseDetailFrame.java

package jvpc.jvpc;

import java.awt.*;
import java.awt.event.*;
import kero.awt.*;
import jvpc.vga.*;

/**
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     24 II 2001
 * @version   24 II 2001
 */
public class BaseDetailFrame
    extends MyFrame
    implements BaseListener
{
    JVPC applet; // sort of parent
    Game game;
    BData base;
    IntInput torp[];
     
    /**
     * Disabled constructor. Use <CODE>BaseDetailFrame(Game,Universe)</code>
     * instead.
     */
    private BaseDetailFrame() {}
  
    public BaseDetailFrame(BData base, JVPC ja) {
	super(JVPC.program+" -- Base Detail "+
	      base.getUniverse().getTurnString());
	applet=ja;
	game = applet.game;

	setLayout(new GridLayout(0, 1));
	torp = new IntInput[VGAPlanets.torpedoes+1];
	for (int i=1; i<=VGAPlanets.torpedoes; i++) {
	    torp[i] = new IntInput(game.getTorpedo(i).getName(), 100, 5, 2);
	    addNumberInput(torp[i], 0, "setTorpAmount");
	}

	setBase(base);
	base.getUniverse().addBaseListener(this);

	pack();
	limitSize();
	show();
    }

    public void setTorpAmount() {
	// Oh well, need to find out which number changed...  Better, I should
	// adapt the addNumberInput() method, so it passes the original event!
	for (int i=1; i<=VGAPlanets.torpedoes; i++) {
	    if (torp[i].getInt() != base.getTorpedoes(i)) {
		// System.err.println();
		int ffOnthouden = torp[i].getInt(); // events are _so_ nice
		Torpedo torpedo = base.getGame().getTorpedo(i);
		int techDiff = torpedo.getTech() - base.getTorpTech();
		if (techDiff > 0) base.raiseTorpTech(techDiff);
		base.buildTorpedoes(i, ffOnthouden - base.getTorpedoes(i));
		base.lowerTorpTech(VGAPlanets.maxTechLevel); // just try
		torp[i].setIntNoAction(base.getTorpedoes(i));
	    }
	}
    }

    public void setBase(BData b) {
	this.base = b;
	for (int i=1; i<=VGAPlanets.torpedoes; i++) {
	    torp[i].setIntNoAction(base.getTorpedoes(i));
	}
    }

    public void baseChanged(BaseEvent be) {
	if (be.getId() == base.getId()) setBase(base);
    }
}
