// File: JVPCConfig.java

package jvpc.jvpc;

import java.util.Hashtable;
import java.io.*;
import java.awt.*;
import java.lang.reflect.*;
import kero.util.*;
import kero.awt.*;

/**
 * Can read pconfig.src like files. Has an interface for pconfig-specific
 * values.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     16 III 1999
 * @version   10 III 2000
 */
public class JVPCConfig
    extends AwtConfig
{
    public int getMinX() {
	try {
	    return getInteger("MinX");
	} catch (NoConfigStringException _) {
	    return 1000;
	}
    }

    public int getMaxX() {
	try {
	    return getInteger("MaxX");
	} catch (NoConfigStringException _) {
	    return 3000;
	}
    }

    public int getMinY() {
	try {
	    return getInteger("MinY");
	} catch (NoConfigStringException _) {
	    return 1000;
	}
    }

    public int getMaxY() {
	try {
	    return getInteger("MaxY");
	} catch (NoConfigStringException _) {
	    return 3000;
	}
    }

    public int getMinFontSize() {
	try {
	    return getInteger("MinFontSize");
	} catch (NoConfigStringException _) {
	    return 8;
	}
    }

    public int getMaxFontSize() {
	try {
	    return getInteger("MaxFontSize");
	} catch (NoConfigStringException _) {
	    return 16;
	}
    }

    public double getMinZoom() {
	try {
	    return getDouble("MinZoom");
	} catch (NoConfigStringException _) {
	    return 0.01; // normal map is 20 pixels
	}
    }

    public double getMaxZoom() {
	try {
	    return getDouble("MaxZoom");
	} catch (NoConfigStringException _) {
	    return 100; // on a screen of 1024x768 fit about 10x7LY
	}
    }

    public boolean getBuggyScrollbars() {
	try {
	    return getBoolean("BuggyScrollbars");
	} catch (NoConfigStringException _) {
	    return false; // default says no bugs, right?
	}
    }

    public String getPlanetString() {
	try {
	    return get("PlanetString");
	} catch (NoConfigStringException _) {
	    return "ntdm";
	}
    }

    public String getShipString() {
	try {
	    return get("ShipString");
	} catch (NoConfigStringException _) {
	    return "ntdm";
	}
    }


    // Color questions, unused so far...

    public Color getEnemyPlanetColor() {
	try {
	    return getColor("EnemyPlanetColor");
	} catch (NoConfigStringException _) {
	    return getEnemyColor();
	}
    }

    public Color getEnemyColor() {
	try {
	    return getColor("EnemyColor");
	} catch (NoConfigStringException _) {
	    return new Color(250, 50, 50);
	}
    }
}
