// File: MapCircle.java

package jvpc.jvpc;

import java.awt.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 4 III 2001
 * @version 4 III 2001
 */
public abstract class MapCircle extends MapLocated {
    public void update(Graphics g, int x, int y, int radius) {
	Rectangle rect = g.getClipBounds();
	if (x+radius < rect.x) return;
	if (y+radius < rect.y) return;
	if (x-radius > rect.x+rect.width) return;
	if (y-radius > rect.y+rect.height) return;
	g.drawOval(x-radius, y-radius, 2*radius, 2*radius);
    }
}
