// File: MapIonstorm.java

package jvpc.jvpc;

import java.awt.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the Lesser GNU General Public License applies)
 * @since 21 May 2004
 */
public class MapIonstorm extends MapCircle {
    Ionstorm ionstorm;

    public MapIonstorm(Map m, Ionstorm e) {
	map = m;
	ionstorm = e;
    }

    public Color getColor() {
	return Color.gray;
    }

    public String getString() {
	String label;
	switch (map.ionstormLabel) {
	case 0:
	    return ionstorm.toString(false);
	case 1:
	    return "Ion"+ionstorm.getId() + " " + ionstorm.getVoltage()+"V";
	}
	return "??";
    }

    public void update(Graphics g, int x, int y) {
	int radius=(int)((double)ionstorm.getRadius()*map.zoom);
	update(g, x, y, radius);
    }
}
