// File: MapLocated.java

package jvpc.jvpc;

import java.awt.*;
import kero.util.*;
import jvpc.vga.*;
import jvpc.extdata.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 4 III 2001
 * @version 4 III 2001
 */
public class MapLocated extends Reporter implements VGAPlanets {
    static Color colorMap[] = { // generic status -> color
	new Color(240, 240, 240), // Unknown
	new Color(240,  50, 50), // Enemy
	new Color(240, 240, 50), // Neutral
	new Color( 30, 120, 30), // Ally
	new Color( 50, 240, 50)  // Self
    };

    static Color playerColorMap[] = { // Player -> color
	new Color(128, 128, 128), // Unknown
	new Color(  0, 125, 200),
	new Color(  0, 200, 125),
	new Color( 75, 250,  75),
	new Color(100, 225, 225),
	new Color(250, 100, 100),
	new Color(200, 100, 200),
	new Color(235, 235, 100),
	new Color(200,   0, 125),
	new Color(105, 105, 255),
	new Color(150, 200,   0),
	new Color(125,   0, 200)
    };

    Map map;
    Located located;

    protected MapLocated() {}

    protected MapLocated(Map m, Located loc) {
	map = m;
	located = loc;
    }

    public static MapLocated createMapLocated(Map m, Located loc) {
	if (loc instanceof Planet) {
	    return new MapPlanet(m, (Planet)loc);
	} else if (loc instanceof Ship) {
	    return new MapShip(m, (Ship)loc);
	} else if (loc instanceof Minefield) {
	    return new MapMinefield(m, (Minefield)loc);
	} else if (loc instanceof Ionstorm) {
	    return new MapIonstorm(m, (Ionstorm)loc);
	} else if (loc instanceof Wormhole) {
	    return new MapWormhole(m, (Wormhole)loc);
	} else if (loc instanceof Explosion) {
	    return new MapExplosion(m, (Explosion)loc);
	} else {
	    return new MapMarker(m, (Marker)loc);
	}
	// return null;
    }

    public Color getColor() {
	return Color.white;
    }

    public String getString() {
	return located.toString();
    }

    public void update(Graphics g, int x, int y) {
	// do nothing
    }
}
