// File: MapMinefield.java

package jvpc.jvpc;

import java.awt.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 4 III 2001
 * @version 5 III 2001
 */
public class MapMinefield extends MapCircle {
    // Map status of minefield -> color
    static Color minefieldStatusColorMap[] = colorMap;
    static Color webminefieldStatusColorMap[] = colorMap;

    Minefield minefield;

    public MapMinefield(Map m, Minefield e) {
	map = m;
	minefield = e;
    }

    public Color getColor() {
	int owner = minefield.getOwner();
	Color c;
	if (owner == 0) {
	  c = Color.white;
	} else {
	  int index = map.universe.getPlayer(owner).getMinefieldStatus();
	  switch (map.colorModel) {
	  case 0:
	    if (minefield.isWeb()) {
	      c = webminefieldStatusColorMap[index];
	    } else {
	      c = minefieldStatusColorMap[index];
	    }
	    break;
	  case 1:
	    c = playerColorMap[owner];
	    break;
	  default:
	    Assert.assert(false);
	    c = Color.white;
	  }
	}
	return c;
    }

    public String getString() {
	String str;
	switch (map.drawMinefieldLabels) {
	case 0:
	    str = "";
	    break;
	case 1:
	    str = (minefield.isWeb()?"Web ":"")+"Minefield "+minefield.getId();
	    break;
	default:
	    str = (minefield.isWeb()?"wm":"m")+minefield.getId();
	    break;
	}
	return str;
    }

    public void update(Graphics g, int x, int y) {
	int radius = (int)((double)minefield.getRadius()*map.zoom);
	update(g, x, y, radius);
    }
}
