// File: MapPlanet.java

package jvpc.jvpc;

import java.awt.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 4 III 2001
 * @version 4 III 2001
 */
public class MapPlanet extends MapLocated {
    Planet planet;

    public MapPlanet(Map m, Planet p) {
	map = m;
	planet = p;
    }

    public Color getColor() {
  	int owner = planet.getOwner();
	Color c;
  	if ((owner == UNKNOWN) || (owner == 0)) {
	    c = Color.gray;
  	} else {
	    switch (map.colorModel) {
	    case 0:
		c = colorMap[map.universe.getPlayer(owner).getPlanetStatus()];
		break;
	    case 1:
		c = playerColorMap[owner];
		break;
	    default:
		Assert.assert(false);
		c = Color.white;
	    }
  	}
	return c;
    }

    public String getString() {
	String label;
	switch(map.planetLabel) {
	case 0:
	    label = "p" + planet.getId();
	    break;
	case 1:
	    label = planet.getName();
	    break;
	case 2:
	    label = planet.toPlanetString(map.planetstring);
	    break;
	default:
	    label = "??";
	    crash(1002, "Should have legal planet label number");
	    break;
	}
	return label;
    }

    public void update(Graphics g, int x, int y) {
	// if ((mapy<0) || (mapy>=dim.height)) continue;
	int size = ((int)Math.ceil(map.zoom * 1.5)) / 2 * 2 + 1;
	if (size < 2) {
	  g.fillRect(x-size/2, y-size/2, size, size); // iff on-screen
	} else {
	  g.fillOval(x-size/2, y-size/2, size, size); // iff on-screen
	}
    }
}
