// File: MapWormhole.java

package jvpc.jvpc;

import java.awt.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 4 III 2001
 * @version 4 III 2001
 */
public class MapWormhole extends MapCircle {
    Wormhole wormhole;

    public MapWormhole(Map m, Wormhole e) {
	map = m;
	wormhole = e;
    }

    public Color getColor() {
	return Color.gray;
    }

    public String getString() {
	String label;
	switch (map.wormholeLabel) {
	case 0:
	    label = "Wormhole " + wormhole.getId();
	    break;
	case 1:
	    label = "w" + wormhole.getId();
	    break;
	default:
	    label = "??";
	    Assert.assert(false);
	    break;
	}
	return label;
    }

    public void update(Graphics g, int x, int y) {
	int radius=(int)((double)wormhole.getRadius()*map.zoom);
	update(g, x, y, radius);
    }
}
