// File: MarkerFrame.java

package jvpc.jvpc;

import java.awt.*;
import java.awt.event.*;
import kero.awt.*;
import jvpc.vga.*;
import jvpc.extdata.*;

/**
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     18 III 2001
 * @version   18 III 2001
 */
public class MarkerFrame extends MyFrame {
    protected Marker marker;
    protected IntInput x, y;
    protected InputField text;

    MarkerFrame() {}

    public MarkerFrame(Marker m) {
	super(JVPC.program+" -- Marker ("+m.getUniverse().getTurnString()+")");
	setLayout(new GridLayout(0, 1));

	Panel p = new Panel(new GridLayout(1, 0));
	x = new IntInput("X:", 9999, 1, 0);
	addNumberInputTo(p, x, KeyEvent.VK_X, "setX");
	y = new IntInput("Y:", 9999, 1, 0);
	addNumberInputTo(p, y, KeyEvent.VK_Y, "setY");
	add(p);

	text = new InputField("Text", "Text can be Long");
	addInputField(text, KeyEvent.VK_T, "setText");

	pack();
	show();

	setMarker(m);
    }

    protected void setMarker(Marker m) {
	marker = m;
	x.setInt(m.getX());
	y.setInt(m.getY());
	text.setText(m.getText());
    }
    
    public void setX() {}
    public void setY() {}
    public void setText() {
	marker.setText(text.getText()); // no event, yet
	dispose();
    }
}
