// File: ScoreFrame.java

package jvpc.jvpc;

import java.awt.*;
import java.awt.event.*;
import kero.awt.*;
import jvpc.vga.*;

/**
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     19 II 2001
 * @version   11 III 2001
 */
public class ScoreFrame
    extends MyFrame
{
    // sort of parent
    JVPC applet;
    Game game;
    Label[][] score = new Label[VGAPlanets.races+2][5];
    
    /**
     * Disabled constructor. Use <CODE>ScoreFrame(Game,Universe)</code>
     * instead.
     */
    private ScoreFrame() {}
  
    public ScoreFrame(String name, Universe universe, JVPC ja) {
	super(name);
	applet=ja;
	game = applet.game;

	Panel p = new Panel(new GridLayout(0, 1));
	p.add(new Label());
	for (int i=1; i<=VGAPlanets.races; i++) {
	    p.add(new Label(game.getLongRace(i)));
	}
	p.add(new Label("total", Label.RIGHT));
	add(p, "Center");

	p = new Panel(new GridLayout(0, 5));
	p.add(new Label("total", Label.RIGHT));
	p.add(new Label("planets", Label.RIGHT));
	p.add(new Label("bases", Label.RIGHT));
	p.add(new Label("capital", Label.RIGHT));
	p.add(new Label("freight", Label.RIGHT));
	for (int i=1; i<=VGAPlanets.races; i++) {
	    for (int j=0; j<5; j++) {
		score[i][j] = new Label("", Label.RIGHT);
		p.add(score[i][j]);
	    }
	}
	for (int j=0; j<5; j++) {
	    score[VGAPlanets.races+1][j] = new Label("", Label.RIGHT);
	    p.add(score[VGAPlanets.races+1][j]);
	}
	add(p, "East");

	setScores(universe);

	pack();
	limitSize();
	show();
    }

    public void setScores(Universe universe) {
	int i, j;
	for (i=1; i<=VGAPlanets.races; i++) {
	    if (universe.getGen(i) != null) break;
	}
	int race = i;
	if (race == VGAPlanets.races + 1) return;
	Gen gen = universe.getGen(i);
	int total[] = new int[5];
	for (i=1; i<=VGAPlanets.races; i++) {
	    score[i][0].setText(""+gen.getScore(i).getTotal());
	    score[i][1].setText(""+gen.getScore(i).getPlanets());
	    total[1] += gen.getScore(i).getPlanets();
	    score[i][2].setText(""+gen.getScore(i).getBases());
	    total[2] += gen.getScore(i).getBases();
	    score[i][3].setText(""+gen.getScore(i).getCapitals());
	    total[3] += gen.getScore(i).getCapitals();
	    score[i][4].setText(""+gen.getScore(i).getFreighters());
	    total[4] += gen.getScore(i).getFreighters();
	}
	for (j=1; j<5; j++) score[VGAPlanets.races+1][j].setText(""+total[j]);
    }

    /**
     * Overrides normal <CODE>add(Component)</code>. This is done because a
     * <CODE>ScoreFrame</code> has no <CODE>Container</code> function anymore.
     */
    public final Component add(Component comp) {
	System.err.println("ScoreFrame(Component) -- Is not a Container, "+
			   comp+" not added");
	return comp;
    }
}
