// File: Selector.java

package jvpc.jvpc;

import java.util.*;
import java.awt.*;
import jvpc.vga.*;

/**
 * Selects one item from a Location.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     2 I 2000
 * @version   2 I 2000
 */
public class Selector
  extends Window // is this used???
{
  class SelectorCanvas
    extends Canvas
  {
    boolean firsttime=true;
    int fontsize;
    Location list;
    Selector selector;
    int lightline;
    Located current;
    public SelectorCanvas(Selector sel,Location loc,int fs) {
      selector=sel;
      list=loc;
      fontsize=fs;
    }
    public Located getCurrent() {
      return current;
    }
    public void highlight(int wx,int wy) {
      if (wy<0) {
	current=null;
	return;
      }
      lightline=wy%fontsize;
System.err.println("highlighting line "+lightline);
      if (list.getPlanet()!=null) {
	if (lightline==0) current=list.getPlanet();
	else if (lightline<=list.getShips().size())
	  current=(Located)list.getShips().elementAt(lightline-1);
	else {
	  current=null;
	  return;
	}
      } else {
	if (lightline<list.getShips().size())
	  current=(Located)list.getShips().elementAt(lightline-1);
	else {
	  current=null;
	  return;
	}
      }
    }
    public void paint(Graphics g) {
      if (firsttime) {
	firsttime=false;
	Font font=g.getFont();
	font=new Font(font.getName(),Font.PLAIN,fontsize);
	FontMetrics metrics=g.getFontMetrics();
	int maxwidth=0;
	Vector ships=list.getShips();
	int height=fontsize*ships.size();
	for (int i=0;i<ships.size();i++) {
	  Ship ship=(Ship)ships.elementAt(i);
	  int w=metrics.stringWidth(ship.getName());
	  if (w>maxwidth) maxwidth=w;
	}
	if (list.getPlanet()!=null) {
	  int w=metrics.stringWidth(list.getPlanet().getName());
	  if (w>maxwidth) maxwidth=w;
	  height+=fontsize;
	}
	selector.setSize(maxwidth,height);
	super.repaint();
	return;
      }
      int rule=1;
      Planet planet=list.getPlanet();
      if (planet!=null) {
	if (rule==lightline) g.setColor(Color.white);
	else g.setColor(Color.black);
	g.drawString(planet.getName(),1,rule*fontsize);
	rule++;
      }
      Vector ships=list.getShips();
      for (int i=0;i<ships.size();i++) {
	Ship ship=(Ship)ships.elementAt(i);
	if (rule==lightline) g.setColor(Color.white);
	else g.setColor(Color.black);
	g.drawString(ship.getName(),1,rule*fontsize);
	rule++;
      }
    }
  }

  SelectorCanvas canvas;

  public Selector(Frame f,Location loc,int fs) {
    super(f);
setLayout(new BorderLayout());
    canvas=new SelectorCanvas(this,loc,fs);
    add(canvas);
  }
  public void highlight(int mapx,int mapy) {
    canvas.highlight(mapx,mapy);
    repaint();
  }
  public Located getCurrent() {
    return canvas.getCurrent();
  }
}
