package kero.awt;

import java.awt.TextField;
import java.awt.Color;
import kero.util.*;
import kero.awt.event.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 13 I 2001
 * @version 13 I 2001
 */
public class DateField extends MyTextField implements InputListener {
    int year, month, day;

    public DateField(String s) {
	super(s);
	illegal = false;
	parseContent();
	setupInputListener();
    }

    public DateField(int year, int month, int day) {
	super(""+day+" "+month+" "+year);
	illegal = false;
	this.year = year;
	this.month = month;
	this.day = day;
	setupInputListener();
    }

    public int getYear() {
	return year;
    }

    public int getMonth() {
	return month;
    }

    /**
     * @return day of month.
     */
    public int getDay() {
	return day;
    }

    protected void parseContent() {
	String content = getText();
	int spaceIndex = content.indexOf(' ');

	String dayString = content.substring(0, spaceIndex);
	System.err.println("day: "+dayString);
	try {
	    day = Integer.parseInt(dayString);
	} catch (NumberFormatException nfe) {
	    setIllegal();
	}

	String tail = content.substring(spaceIndex+1, content.length());
	spaceIndex = tail.indexOf(' ');
	String monthString = tail.substring(0, spaceIndex);
	System.err.println("month: "+monthString);
	int i;
	for (i=0; i<MyDate.shortMonthString.length; i++) {
	    if (MyDate.shortMonthString[i].equals(monthString)) {
		month = i;
		break;
	    }
	}
	if (i == MyDate.shortMonthString.length) setIllegal();

	String yearString = tail.substring(spaceIndex+1, tail.length());
	System.err.println("year: "+yearString);
	try {
	    year = Integer.parseInt(yearString);
	} catch (NumberFormatException nfe) {
	    setIllegal();
	}
    }

    public void inputGiven(InputEvent ie) {
	parseContent();
    }
}
