// File: Display.java

package kero.awt;

import java.awt.*;
import java.awt.event.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 9 II 2001
 * @version 9 II 2001
 */
public class Display
    extends Container
{
    Thing thing;

    public Display() {}

    public void addThing(Thing t, int x, int y) {
	thing = t;
	add(thing);
	thing.setBounds(x, y, 20, 20);
	thing.display = this;
    }

    // Layouting stuff

    void requestLocation(Thing t, int x, int y) {
	t.setLocation(x, y);
	repaint();
    }

    public Dimension getPreferredSize() {
	return new Dimension(60, 60);
    }


    // test main program

    public static void main(String[] arg) {
	Frame f = new MyFrame("Display/Thing test");
	f.addWindowListener(new FrameAdapter());
	MenuBar mb = new MenuBar();
	Menu systemMenu = new Menu("System");
	systemMenu.add(new MenuItem("Click me!"));
	systemMenu.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent ae) {
		System.err.println("Click me again! again! again!");
	    }
	});
	mb.add(systemMenu);
	f.setMenuBar(mb);

	f.setLayout(new BorderLayout());
	Display d = new Display();
	f.add(d, "Center");
	d.addThing(new Thing("Hello!"), 20, 20);
	d.addThing(new Thing("Good Bye"), 40, 40);
	Label reportLabel = new Label("Reports & Messages should go here");
	f.add(reportLabel, "South");
	f.pack();
	f.show();
    }
}
