// File: Thing.java

package kero.awt;

import java.awt.*;
import java.awt.event.*;

/**
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 9 II 2001
 * @version 9 II 2001
 */
public class Thing
    extends Component
    implements MouseListener, MouseMotionListener
{
    String name;
    Display display;

    public Thing(String aName) {
	name = aName;
	addMouseListener(this);
	addMouseMotionListener(this);
    }


    // mouse stuff

    int origX, origY, mouseX, mouseY;

    public void mousePressed(MouseEvent me) {
	System.err.println(me);
	Point p = getLocation();
	origX = p.x;
	origY = p.y;
	mouseX = p.x + me.getX();
	mouseY = p.y + me.getY();
    }

    public void mouseReleased(MouseEvent me) {
	System.err.println(me);
    }
    public void mouseClicked(MouseEvent me) {
	System.err.println(me);
    }

    public void mouseEntered(MouseEvent me) {
	System.err.println(me);
	// report(name);
    }

    public void mouseExited(MouseEvent me) {
	System.err.println(me);
	// report(""); // perhaps just leave comment where it was?
    }

    public void mouseMoved(MouseEvent me) {
	System.err.println(me);
    }

    public void mouseDragged(MouseEvent me) {
	System.err.println(me);
	Point p = getLocation();
	int x = p.x + me.getX();
	int y = p.y + me.getY();

	display.requestLocation(this, origX + x - mouseX, origY + y - mouseY);
    }


    // painting stuff

    public void paint(Graphics g) {
	update(g);
    }

    public void update(Graphics g) {
	g.setColor(Color.yellow);
	Dimension dim = getSize();
	g.fillRect(0, 0, dim.width, dim.height);
	g.setColor(Color.black);
	g.drawString(name, 2, 12); // knowing I am 20, 20 big
    }
}
