// File: InputEvent.java

package kero.awt.event;

import java.awt.AWTEvent;

/**
 * Single type of event, used to wrap around all types of events possibly
 * passed around. Most important, FocusEvents are caught, which usually imply
 * someone is done editing a TextField or something like that.
 *
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since 5 I 2001
 * @version 5 I 2001
 */
public class InputEvent extends AWTEvent {
    public static final int INPUT_GIVEN = AWTEvent.RESERVED_ID_MAX + 250;

    public InputEvent(Object source, int type) {
	super(source, type);
    }

    public InputEvent(Object source, int type, String input) {
	super(source, type);
    }
}
