// File: Assert.java

package kero.util;

/**
 * The static method Assert.assert() functions like the assert() call in C.
 *
 * @author Rutger Nijlunsing
 * @copyright Rutger Nijlunsing (the GNU General Public License applies)
 */
public class Assert {
  static boolean ignore = false;	// if true, ignore failed assertions

  static void exception() throws AssertException {
    throw new AssertException();
  }

  public static void setIgnore(boolean flag) {
    ignore = flag;
  }

  public static void assert(boolean t) {
    if (!t) {
      System.err.println("Assertion failed");
      try {
	exception();
      } catch(Exception e) {
	e.printStackTrace();
      }
      if (!ignore) {
	System.exit(1);
      }
    }
  }
}

class AssertException extends Exception {
}

