// File: BinaryTree.java

package kero.util;

import java.util.Enumeration;

/**
 * BinaryTree, consisting of BinaryNodes
 *
 * @author Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Library Public License applies)
 * @since 25 V 2000
 * @version 10 IX 2000
 */
public class BinaryTree extends Reporter {
    protected BinaryNode root;

    public BinaryTree() {
	this(null);
    }

    public BinaryTree(BinaryNode node) {
	root = node;
    }

    public BinaryNode getRoot() {
	return root;
    }

    public boolean isRootNode(BinaryNode node) {
	return (root == node);
    }

    public Enumeration getNodes() {
	return root.elements();
    }

    public void setRoot(BinaryNode node) {
	root = node;
    }

    public void remove(BinaryNode node) {
	assert(false); // fuck I don't want to rethink this all.
	// I'll copy it Monday :-(
	if (!root.isAncestorOf(node)) {
	    report("Trying to remove node "+node+
		   ", which is not a part of this BinaryTree "+this);
	    return;
	}

	BinaryNode replacement = node.getNext();
	if ((replacement == null) || (Math.random() >= 0.5)) {
	    BinaryNode prev = node.getPrev();
	    if (prev != null) replacement = prev;
	}

	if (replacement != null) {
	    // unlink replacement
	    assert(replacement.right == null || replacement.left == null);
	    BinaryNode sibling = replacement.right;
	    if (sibling == null) sibling = replacement.left;
	    BinaryNode parent = replacement.parent;
	    if (parent != null) {
		if (parent.right == replacement) parent.setRight(sibling);
		else parent.setLeft(sibling);
	    }
	    if (sibling != null) sibling.setParent(parent);

	    // relink replacement
	    replacement.setParent(node.parent);
	    replacement.setLeft(node.left);
	    replacement.setRight(node.right);
	}

	// take out the node
	node.setParent(null);
	node.setLeft(null);
	node.setRight(null);

	if (node == root) root = replacement;
    }

    public String toString() {
	return root.toString(0);
    }
}
