// File: Matrix.java

package kero.util;

/**
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU Public License applies)
 * @since     15 II 2000
 * @version   15 II 2000
 */
public class Matrix {
  protected int rows, columns;
  public double[][] value; // sorry for the publicity...

  public Matrix(int r, int c) {
    rows = r;
    columns = c;
    value = new double[rows][columns];
  }

  public void setValues(double[] v) {
    if (v.length != rows * columns) return;
    for (int i=0; i<rows; i++) {
      for (int j=0; j<columns; j++) {
	value[i][j] = v[i*columns + j];
      }
    }
  }

  public Matrix plus(Matrix m) {
    if ((m.rows != rows) || (m.columns != columns)) return null;
    Matrix result = new Matrix(rows, columns);
    for (int i=0; i<rows; i++) {
      for (int j=0; j<columns; j++) {
	result.value[i][j] = value[i][j] + m.value[i][j];
      }
    }
    return result;
  }

  public Matrix times(Matrix m) {
    if (m.rows != columns) return null;
    Matrix result = new Matrix(rows, m.columns);
    for (int i=0; i<rows; i++) {
      for (int j=0; j<m.columns; j++) {
	for (int k=0; k<columns; k++) {
	  result.value[i][j] += value[i][k] * m.value[k][j];
	}
      }
    }
    return result;
  }

  public String toString() {
    StringBuffer result = new StringBuffer(256);
    result.append("[ ");
    for (int i=0; i<rows; i++) {
      if (i!=0) result.append(", ");
      result.append("[ ");
      for (int j=0; j<columns; j++) {
	if (j!=0) result.append(", ");
	result.append(value[i][j]);
      }
      result.append(" ]");
    }
    result.append(" ]");
    return result.toString();
  }
}
