// File: Beam.java

package jvpc.vga;

import java.io.*;

/**
 * One beam from BEAMSPEC.DAT
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     24 I 1999
 * @version   29 XII 2000
 */
public class Beam
    implements VGAPlanets
{
    String name, shortname;
    int mc,trit,dur,molyb;
    int mass,tech,kill,expl;

    public Beam() {}

    public void readFrom(LSBReader source) throws IOException {
	name=source.readString(BEAMNMSIZE).toString();
	shortname=name.substring(0,name.indexOf(' '));
	mc=source.readShort();
	trit=source.readShort();
	dur=source.readShort();
	molyb=source.readShort();
	mass=source.readShort();
	tech=source.readShort();
	kill=source.readShort();
	expl=source.readShort();
    }

    public String getName() {
	return name;
    }

    public String getShortName() {
	return shortname;
    }

    public int getMass() {
	return mass;
    }

    public int getTech() {
	return tech;
    }
}
