// File: BeamGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates Beams from the file "beamspec.dat".
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     24 I 1999
 * @version   21 XII 1999
 */
public class BeamGen extends Generator {
  /**
   * Constructs a Beam generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public BeamGen(InputStream is) throws IOException {
    super(is);
  }

  public void generateAll(Universe u) {
    crash(1000, "No, no, no. Use generateAll(Game)");
  }

  /**
   * Generates 10 <CODE>Beam</code> objects.
   */
  public void generateAll(Game game) {
    for (int i=1;i<=beams;i++) {
      Beam beam=new Beam();
      try {
	beam.readFrom(source);
	game.beam[i]=beam; // hack...
      } catch (IOException ioe) {
	crash(11, "Error while reading beamspec.dat: "+ioe);
      }
    }
  }
}
