// File: Cargo.java

package jvpc.vga;

import kero.util.*;

/**
 * Abstracts from the different types of cargo. Divides them in groups, such
 * that functions like maxCargo() take precisely those types of cargo into
 * account that are necessary.
 *
 * <P>Greatly shortens CargoTransfer (factor CARGOTYPES=8).
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     30 I 2000
 * @version   6 II 2000
 */
public class Cargo
  extends Reporter
  implements VGAPlanets
{
  public final static int NEUTRONIUM = 0;
  public final static int TRITANIUM = 1;
  public final static int DURANIUM = 2;
  public final static int MOLYBDENIUM = 3;
  public final static int SUPPLIES = 4;
  public final static int MC = 5;
  public final static int COLCLANS = 6;
  public final static int AMMUNITION = 7;
  public final static int CARGOTYPES = 8;

  public final static int FUEL = 0;
  public final static int CARGO = 1;
  public final static int MONEY = 2;
  public final static int CARGOGROUPS = 3;

  public final static int FIGHTER = -1;

  public final static int[] group = {0, 1, 1, 1, 1, 2, 1, 1};
  public final static boolean[] frombase = {false, false, false, false,
					    false, false, false, true};

  int amount;

  static {
    Assert.assert(group.length == CARGOTYPES);
    Assert.assert(frombase.length == CARGOTYPES);
  }

  public Cargo() {
    amount = UNKNOWN;
  }

  public Cargo(int amount) {
    this.amount = amount;
  }
}
