// File: CargoTransferable.Java 

package jvpc.vga;

/**
 * Defines the interface for transfering cargo from ships to planets and vice
 * versa.
 *
 * <P>This interface makes it impossible for instances of the class Planet to
 * transfer cargo.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     23 I 2000
 * @version   12 III 2000
 */
public interface CargoTransferable
{
  public int maxCargo(int cargotype);
  public int cargoUsed(int cargotype);
  public int cargoLeft(int cargotype);
  public int getCargo(int cargotype);
  public void transferCargoTo(CargoTransferable partner,
			      int cargotype, int amount);
}
