// File: Circle.java

package jvpc.vga;

import kero.util.*;

/**
 * Circle at integer location
 */
public class Circle extends MyPoint implements Intersection
{
  int units;			// Sqr(radius)

  public Circle(MyPoint center) {
    super(center);
    units = 0;
  }

  public Circle(MyPoint center, int r) {
    super(center);
    units = r * r;
  }

  public double getRadius() {
    return Math.sqrt(units);
  }

  /**
   * Return the square of the radius
   */
  public int getSqrRadius() {
    return units;
  }

  public void setRadius(double r) {
    units = (int)(r * r);
  }

  /**
   * Set the square of the radius
   */
  public void setSqrRadius(int units) {
    this.units = units;
  }

  /**
   * Returns true if point p lies on this object
   */
  public boolean liesOn(MyPoint p) {
    return ((p.getXint() - x) * (p.getYint() - y)) == units;
  }

  /**
   * Returns true if point p lies within this object
   */
  public boolean liesWithin(MyPoint p) {
    return (Mymath.sqr(p.getXint() - x) + 
	    Mymath.sqr(p.getYint() - y)) <= units;
  }

  /**
   * Returns true if line l lies (partly) within this object
   */
  public boolean liesWithin(Line l) {
    Assert.assert(false);	// TODO
    return false;
  }

  /**
   * Returns true if rectangle r lies (partly) within this object
   */
  public boolean liesWithin(MyRectangle r) {
    Assert.assert(false);	// TODO
    return false;
  }
}
