// Dated.java

package jvpc.vga;

import kero.util.*;

/**
 * Provides information about the turnnumber.
 *
 * <P>Typical subclasses are: password, universe, config, scores, hulltype,
 * alliance-info.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     10 VII 1998
 * @version   21 XII 1999
 */
public abstract class Dated
  extends Reporter
  implements VGAPlanets
{
  Universe universe;

  public Dated(Universe u) {
    universe = u;
  }

  public Universe getUniverse() {
    return universe;
  }

  public Game getGame() {
    return universe.getGame();
  }

  public int getTurnNumber() {
    return universe.getTurnNumber();
  }

  public void setUniverse(Universe u) {
    universe = u;
  }
}
