// File: Engine.java

package jvpc.vga;

import java.io.*;

/**
 * One engine from ENGSPEC.DAT
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     20 XII 1998
 * @version   29 XII 2000
 */
public class Engine
    implements VGAPlanets
{
    StringBuffer name;
    short mc,trit,dur,molyb;
    int tech;
    int[] usage;

    public Engine() {
	usage=new int[maxWarp];
    }

    public void readFrom(LSBReader source) throws IOException {
	name=source.readString(ENGNMSIZE);
	mc=source.readShort();
	trit=source.readShort();
	dur=source.readShort();
	molyb=source.readShort();
	tech=source.readShort();
	for (int j=0;j<maxWarp;j++) {
	    usage[j]=source.readInt();
	}
    }

    public String getName() {
	return name.toString();
    }

    public int getTech() {
	return tech;
    }

    /**
     * Returns fuel usage in percentage from ``normal'' usage.
     * about 100% is normal, lower is good, higher is bad.
     */
    public double getNeutrUsage(int warp) {
	int index=warp-1;
	return (double)usage[index]/warp/warp;
    }
}
