// File: EngineGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates Engines from the file "engspec.dat".
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     20 XII 1998
 * @version   21 XII 1999
 */
public class EngineGen extends Generator {
  /**
   * Constructs an Engine generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public EngineGen(InputStream is) throws IOException {
    super(is);
  }

  public void generateAll(Universe u) {
    crash(1000, "No, no, no. Use generateAll(Game)");
  }

  /**
   * Generates 10 <CODE>Engine</code> objects.
   */
  public void generateAll(Game game) {
    for (int i=1;i<=engines;i++) {
      Engine engine=new Engine();
      try {
	engine.readFrom(source);
	game.engine[i]=engine; // hack...
      } catch (IOException ioe) {
	crash(11, "Error while reading engspec.dat: "+ioe);
      }
    }
  }
}
