// File: Explosion.java

package jvpc.vga;

import java.io.*;

/**
 * Contains an explosion of a ship somewhere in outer space. Could have been an
 * own ship lost in battle as well.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     13 I 1999
 * @version   15 I 1999
 */
public class Explosion
  extends Located
{
  int shipid; // id of the exploded ship
  String name;

  public Explosion(Universe u) {
    super(u);
  }

  public void readFromUtil(LSBReader source) throws IOException {
    x=source.readShort();
    y=source.readShort();
    shipid=source.readShort();
    if (getUniverse().atLeastPHostVersion((byte)3, (byte)4, 'a')) {
       name = source.readString(20).toString();
    }
  }

  public int getShipID() {
    return shipid;
  }

  public String toString() {
    return "Explosion of ship #"+shipid+" @("+x+","+y+")";
  }
}
