// File: FileTooSmall

package jvpc.vga;

import java.io.IOException;

/**
 * Thrown when the end-of-file is reached. Can be constructed with some info
 * concerning what happened.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     10 VII 1998
 * @version   25 VII 1998
 */
public class FileTooSmall extends IOException {
  public FileTooSmall() {
    super("File too small");
  }

  public FileTooSmall(String filename) {
    super("File "+filename+" too small");
  }

  public FileTooSmall(String filename,long pos) {
    super("File "+filename+" too small at position "+pos);
  }

  public FileTooSmall(String filename,long pos,String reason) {
    super("File "+filename+" too small @"+pos+", when "+reason);
  }
}
