// File: GenGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates <CODE>Gen</code>objects.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     29 XI 1998
 * @version   15 I 1999
 */
public class GenGen
  extends Generator
{
  private int player;
  private boolean isreal; // is this for real genX.dat or for a result?
  
  /**
   * Constructs a Gen generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public GenGen(InputStream is,int pl,boolean ir) throws IOException {
    super(is);
    player=pl;
    isreal=ir;
  }

  public GenGen(Generator g,int pl,boolean ir) throws IOException {
    super(g);
    player=(short)pl;
    isreal=ir;
  }

  /**
   * Generates a <CODE>Gen</code> object found in <CODE>pis</code>.
   * It is only one object containing gen (general?) information of one player,
   * like password, timestamp and checksums.
   */
  public Gen generate() {
    Gen gen=new Gen();
    gen.readGen(source,player,isreal);
    return gen;
  }
}
