// File: Generator.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;
import kero.util.*;

/**
 * Provides construction facilities for Dated subclasses.
 * Most generator subclasses will be directly linked to a VGA-Planets file.
 * This class is declared abstract, because the method
 * <CODE>generateAll()</code> should be implemented.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     10 VII 1998
 * @version   21 XII 1999
 */
public abstract class Generator extends Reporter implements VGAPlanets {
  // Universe universe;
  LSBReader source;

  public Generator() {};

  public Generator(InputStream fis) { // FileInputStream!!!
    // BufferedInputStream bis=new BufferedInputStream(is);
    File file = InputFileOpener.getLastOpenedFile(); // annoying
    long filelength = file.length();
    int fl = (int)filelength;
    if (fl != filelength) crash(1, "File too big!"); // should set a maximum?
    byte[] b = new byte[(int)filelength];
    try {
      fis.read(b, 0, (int)filelength);
    } catch (IOException ioe) {
      crash(1000, "Nou ja, zeg! "+ioe);
    }
    ByteArrayInputStream bis = new ByteArrayInputStream(b);
    source=new LSBReader(bis);
  }

  public Generator(Generator g) {
    this.source=g.source;
  }

    public static void copyFileToDir(String filename, String dirname) throws IOException {
	File file = new File(filename);
	File dir = new File(dirname);
	if (!dir.exists()) {
	    dir.mkdirs();
	    if (!dir.exists()) {
		System.err.println("Need to recreate dir-File");
		dir = new File(dirname);
	    }
	}
	File copy = new File(dir, file.getName());
	if (file.getAbsolutePath().equals(copy.getAbsolutePath())) {
	    // prevent copying file onto itself (=> size 0)
	    return;
	}
	System.err.println("Copying "+file.getAbsolutePath()+" to "+copy.getAbsolutePath());
	FileInputStream fis = new FileInputStream(file);
	FileOutputStream fos = new FileOutputStream(copy);
	byte buf[] = new byte[64*1024];
	while (true) {
	    int amount = fis.read(buf);
	    if (amount > 0) {
		fos.write(buf, 0 /*offset*/, amount);
	    } else {
		break;
	    }
	}
	fis.close();
	fos.close();
    }
}
