// File: GravityWell.java

/**
 * @author Rutger Nijlunsing
 * @since 19990414
 */

package jvpc.vga;

import java.util.*;

public class GravityWell {
    public static boolean liesIn(PConfig config, int dx, int dy) {
	if (config.allowGravityWells()) {
	    if (config.roundGravityWell()) {
		int distance = Math.max(Math.abs(dx), Math.abs(dy));
		return distance <= config.gravityWellRange();
	    } else {
		int distance = Mymath.sqr(dx) + Mymath.sqr(dy);
		return distance <= Mymath.sqr(config.gravityWellRange());
	    }
	} else {
	    return false;
	}
    }

    /**
     * Returns true if a warpwell could transfer a ship over vector
     * @param diff given a config of @param config
     */
    public static boolean liesIn(PConfig config, MyPoint diff) {
	return liesIn(config, diff.getXint(), diff.getYint());
    }

    /**
     * Returns true if ship at location @param ship lies in warpwell of planet at
     * location @param planet given a config of @param config
     */
    public static boolean liesIn(PConfig config, MyPoint planet, MyPoint ship) {
	return liesIn(config, planet.sub(ship));
    }
}
