// File: HullGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates Hulls from the file "hullspec.dat".
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     17 I 1999
 * @version   21 XII 1999
 */
public class HullGen extends Generator {
  /**
   * Constructs a Hull generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public HullGen(InputStream is) throws IOException {
    super(is);
  }

  /**
   * Generates 10 <CODE>Hull</code> objects.
   */
  public void generateAll(Game game) {
    for (int i=1;i<=hulls;i++) {
      Hull hull=new Hull(game,i);
      try {
	hull.readFrom(source);
	game.hull[i]=hull; // hack Hull into Game...
      } catch (IOException ioe) {
	crash(11, "Error while reading hullspec.dat: "+ioe);
      }
    }
  }
}
