// File: JavaPDK.java

package jvpc.vga;

import kero.util.*;

/**
 * Interface to PDK (Phost)
 * @see http://www-personal.engin.umich.edu/~asterian/phost3
 * @author Rutger Nijlunsing
 */
public class JavaPDK {
    static boolean loaded = false; // true iff we've got the lib loaded
    static boolean inited = false; // true iff we've got the lib initialised

    public static native void InitPHOSTLib();
    public static native void FreePHOSTLib();

    static {
	try {
	    System.loadLibrary("PDKWrapper");
	    System.loadLibrary("pdk");	// Load Phost library
	    loaded = true;
	    System.out.println("PDK found and loaded");
	    InitPHOSTLib();
	} catch (Exception e) {
	    System.out.println(e);
	}
    }

    public static void init() {
	Assert.assert(loaded && !inited);
	InitPHOSTLib();
	inited = true;
    }

    public static void free() {
	Assert.assert(loaded && inited);
	FreePHOSTLib();
	inited = false;
    }    

}
