// File: Line.java

package jvpc.vga;

import kero.util.*;

public class Line implements Intersection {
  MyPoint from;			// First point of line
  MyPoint dir;			// Direction of line

  public MyPoint getFrom() {
    return from;
  }

  public MyPoint getDirection() {
    return dir;
  }

  public MyPoint getTo() {
    return from.add(dir);
  }

  public void setFrom(MyPoint from) {
    this.from = from;
  }

  public void setDirection(MyPoint dir) {
    this.dir = dir;
  }

  public Line(MyPoint from, int dx, int dy) {
    setDirection(new MyPoint(dx, dy));
    setFrom(from);
  }

  public Line(MyPoint from, MyPoint dir) {
    setFrom(from);
    setDirection(dir);
  }

  /**
   * Returns true if point p lies on this object
   */
  public boolean liesOn(MyPoint p) {
    // FIXME: now only checks the start- and end-point of the line
    return
      from.liesOn(p) || getTo().liesOn(p);
  }

  /**
   * Returns true if point p lies within this object
   */
  public boolean liesWithin(MyPoint p) {
    return liesOn(p);		// A line _is_ its interior
  }

  /**
   * Returns true if line l lies (partly) within this object
   */
  public boolean liesWithin(Line l) {
    Assert.assert(false);	// TODO
    return false;
  }

  /**
   * Returns true if rectangle r lies (partly) within this object
   */
  public boolean liesWithin(MyRectangle r) {
    Assert.assert(false);	// TODO    
    return false;
  }

}
