// File: MissionGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;
import kero.util.*;

/**
 * Generates Missions from the file "mission.ini".
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     23 V 1999
 */
public class MissionGen {
  //  public MissionGen() {}

  /**
   * Generates all extended missions into the class Mission.
   */
  public void generateExtendedMissions(Game game, LineReader reader) throws IOException {
    reader.skipSpace();
    while (reader.available()>0) {
      // System.err.println("available: "+reader.available()+".");
      int id=Integer.parseInt(reader.readAlphaNumericString());
      reader.skipSpace();
      String rest=reader.readRestOfLine();
      int restlen=rest.length();
      String text;
      boolean useint=false,usetarget=false;
      String inthint=null,targethint=null;
      if ((restlen>=1) && (rest.charAt(restlen-1)=='#')) usetarget=true;
      if (usetarget && (restlen>=2) && (rest.charAt(restlen-2)=='*'))
	useint=true;
      if (!usetarget && (restlen>=1) && (rest.charAt(restlen-1)=='*'))
	useint=true;
      int index=-1,i2;
      if (useint || usetarget) {
	index=rest.indexOf("(");
	text=rest.substring(0,index-1);
	i2=index;
	if (useint) {
	  index=rest.indexOf("I:",i2);
	  boolean finished=false;
	  while ((i2<restlen) && !finished) {
	    char c=rest.charAt(i2);
	    if ((c==' ') || (c==')')) finished=true;
	    else i2++;
	  }
	  inthint=rest.substring(index+2,i2);
	}
	if (usetarget) {
	  index=rest.indexOf("T:",i2);
	  i2=index+2;
	  boolean finished=false;
	  while ((i2<restlen) && !finished) {
	    char c=rest.charAt(i2);
	    if ((c==' ') || (c==')')) finished=true;
	    else i2++;
	  }
	  targethint=rest.substring(index+2,i2);
	}
      } else {
	text=rest;
      }
      game.putMission(new Mission(id,text,inthint,targethint));
    }
  }
}
