// File: MyPoint.java

package jvpc.vga;

import java.awt.*;
import kero.util.*;

public class MyPoint extends Point implements Intersection {

  public String toString() {
    return ("(" + getXint() + "," + getYint() + ")");
  }

  public MyPoint(MyPoint p) {
    super(p);
  }

  public MyPoint(int x, int y) {
    super(x,y);
  }

  public MyPoint add(MyPoint b) {
    return new MyPoint(x + b.x, y + b.y);
  }

  public MyPoint add(int x, int y) {
    return new MyPoint(this.x + x, this.y + y);
  }

  public MyPoint sub(MyPoint b) {
    return new MyPoint(x - b.x, y - b.y);
  }

  public MyPoint sub(int x, int y) {
    return new MyPoint(this.x - x, this.y - y);
  }

  public int getXint() {
    return x;
  }

  public int getYint() {
    return y;
  }

  public double distance(MyPoint b) {
    int dx = b.x - x;
    int dy = b.y - y;
    return Math.sqrt(dx*dx + dy*dy);
  }

  public double distance(int x, int y) {
    int dx = x - this.x;
    int dy = y - this.y;
    return Math.sqrt(dx*dx + dy*dy);
  }

  public double length() {
    return Math.sqrt(x*x + y*y);
  }

  /**
   * Returns true if point p lies on this object
   */
  public boolean liesOn(MyPoint p) {
    Assert.assert(false);	// TODO
    return false;
  }

  /**
   * Returns true if point p lies within this object
   */
  public boolean liesWithin(MyPoint p) {
    Assert.assert(false);	// TODO
    return false;
  }

  /**
   * Returns true if line l lies (partly) within this object
   */
  public boolean liesWithin(Line l) {
    Assert.assert(false);	// TODO
    return false;
  }

  /**
   * Returns true if rectangle r lies (partly) within this object
   */
  public boolean liesWithin(MyRectangle r) {
    Assert.assert(false);	// TODO
    return false;
  }

}
