// File: MyString.java

package jvpc.vga;

/**
 * Some nice extensions of Strings, as we wish to have them.
 * Why is String final?
 *
 * @author Rutger Nijlunsing
 * @author Kero van Gelder
 * @copyright Rutger and Kero (the GNU General Public License applies)
 * @since 13 I 1998
 * @version 13 I 1998
 */
public class MyString {

  /**
   * Return str lowercase
   */
  static public StringBuffer toLower(String str) {
    StringBuffer res = new StringBuffer(str);
    for (int i=0; i<str.length(); i++) {
      res.setCharAt(i,Character.toLowerCase(str.charAt(i)));
    }
    return res;
  }


  /**
   * Return str uppercase
   */
  static public StringBuffer toUpper(String str) {
    StringBuffer res = new StringBuffer(str);
    for (int i=0; i<str.length(); i++) {
      res.setCharAt(i,Character.toUpperCase(str.charAt(i)));
    }
    return res;
  }

  /**
   * Strips trailing characters zero from a String.
   * @param sb String to be stripped.
   * @return StringBuffer that has been stripped.
   */
  public static StringBuffer stripTrailingZeroes(String sb) {
    StringBuffer result=new StringBuffer(sb);
    int i=result.length()-1;
    while ((i>=0) && (result.charAt(i)==(char)0)) i--;
    result.setLength(i+1);
    return result;
  }
}
