package jvpc.vga;

public class Mymath {
  public static int sqr(int w) {
    return (w*w);
  }

  public static int sign(double val) {
    if (val < 0)
      return -1;
    if (val > 0)
      return 1;
    return 0;
  }

  /**
   * Returns true if val lies in [min,max)
   */
  public static boolean between(int val, int min, int max) {
    return (val>=min) && (val<max);
  }

  /**
   * Bound integer
   */
  public static int bound(int val, int min, int max) {
    if (val < min)
      return min;
    if (val > max)
      return max;
    return val;
  }

  /**
   * Return random integer in the range [0, to)
   */
  public static int random(int to) {
    return (int)(Math.random() * to);
  }

  /**
   * Return random integer in the range [from, to)
   */
  public static int random(int from, int to) {
    return from + (int)(Math.random() * (to - from));
  }

  /**
   * Round double to nearest integer.
   *
   * Values that have a fractional part of exactly 0.5 are rounded to
   * the nearest even integer (e.g., 8.5 becomes 8, 9.5 becomes 10)
   */
  public static int ernd(double x) {
    double fract = x - (int)x;
    if (fract == 0.5) {
      return ((int)(x/2 + 0.5))*2;
    } else {
      return (int)(x + 0.5);
    }
  }

  /**
   * Round double to first integer towards zero
   */
  public static int trunc(double x) {
    return (int)(x < 0 ? Math.ceil(x) : Math.floor(x));
  }

    /** @return String with digits characters representing number. */
    public static String formatNumber(int number, int digits) {
	StringBuffer res = new StringBuffer(digits);
	for (int i=0; i<digits; i++) {
	    res.append("0");
	}
	for (int i=digits-1; i>=0; i--) {
	    res.setCharAt(i, "0123456789".charAt(number % 10));
	    number /= 10;
	}
	return res.toString();
    }

    /** @return String with digits characters representing number. */
    public static String formatNumber(double number, int digits) {
	// FIXME: make it more efficient
	int factor = 1;
	for (int i=0; i<digits; i++) {
	    factor *= 10;
	}
	return "" + (int)number + "." +
	    formatNumber((int)(number*factor%factor), digits);
    }
}
