// File: Natives.java

package jvpc.vga;

/**
 * @since     19 XII 1999
 * @version   21 XII 1999
 */
public class Natives implements VGAPlanets {
  public static final int NONE = 0;
  public static final int HUMANOID = 1;
  public static final int BOVINOIDS = 2;
  public static final int REPTILIAN = 3;
  public static final int AVIAN = 4;
  public static final int AMORPHOUS = 5;
  public static final int INSECTOID = 6;
  public static final int AMPHIBIAN = 7;
  public static final int GHIPSOLDAL = 8;
  public static final int SILICONOID = 9;

  private static final String[] name = {
    "",
    "Humanoid",
    "Bovinoids",
    "Reptilian",
    "Avian",
    "Amorphous",
    "Insectoid",
    "Amphibian",
    "Ghipsoldal",
    "Siliconoid"
  };

  private static final String[] shortname = {
    "",
    "Hum",
    "Bov",
    "Rept",
    "Av",
    "Amor",
    "Ins",
    "Amph",
    "Ghip",
    "Sil"
  };

  public static final String getName(int natindex) {
    if (natindex == UNKNOWN) return "?";
    if (natindex < 0) return "nat "+natindex+"?";
    if (natindex >= name.length) return "nat "+natindex+"?";
    else return name[natindex];
  }

  public static final String getShortName(int natindex) {
    if (natindex == UNKNOWN) return "?";
    if (natindex < 0) return "nat "+natindex+"?";
    if (natindex >= name.length) return "nat "+natindex+"?";
    else return shortname[natindex];
  }
}
