// File: PConfigGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;
import kero.util.*;

/**
 * Provides construction facilities for Dated subclasses.
 * Most generator subclasses will be directly linked to a VGA-Planets file.
 * This class is declared abstract, because the method
 * <CODE>generateAll()</code> should be implemented.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     18 XII 1998
 * @version   21 XII 1999
 */
public class PConfigGen
  extends Reporter
{
  LineReader source;

  public PConfigGen(InputStream is) {
    try {
      source=new LineReader(is);
    } catch (IOException ioe) {
      crash(11, "Error in PConfigGen(InputStream): "+ioe);
    }
  }

  public void generateAll(Universe u) throws IOException {
    PConfig pconfig=new PConfig();
    pconfig.readFrom(source);
    u.putConfig(pconfig);
  }
}
