// File: RaceNMGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates Racenames from the file "race.nm".
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     14 III 1999
 * @version   21 XII 1999
 */
public class RaceNMGen extends Generator {
  /**
   * Constructs a RaceNM generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public RaceNMGen(InputStream is) throws IOException {
    super(is);
  }

  /**
   * Generates all <CODE>RaceNM</code> objects.
   */
  public void generateAll(Game game) {
    try {
      for (int i=1;i<=races;i++) 
	game.racelong[i]=source.readString(RACELONGSIZE).toString().trim();
      for (int i=1;i<=races;i++) 
	game.raceshort[i]=source.readString(RACESHORTSIZE).toString().trim();
      for (int i=1;i<=races;i++) 
	game.raceadj[i]=source.readString(RACEADJSIZE).toString().trim();
    } catch (IOException ioe) {
      crash(11, "Error while reading raceNM.dat: "+ioe);
    }
  }
}
