// File: RstOrTrn.java

package jvpc.vga;

/**
 * Provides information whether data belongs to the result or the turn.
 * VGA-Planets is made by Tim Wisseman.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     10 VII 1998
 */
public class RstOrTrn extends Dated {
  public final static int TRN=30;
  public final static int RST=31;

  public RstOrTrn() {
    super(null);
  }

  public RstOrTrn(Universe u) {
    super(u); // also sets universe
  }

  public int get() {
    return universe.get();
  }

  public PConfig getConfig() {
    return universe.getConfig();
  }

  public boolean isRst() {
    return universe.get() == RST;
  }

  public boolean isTrn() {
    return universe.get() == TRN;
  }

  public boolean isEditable() {
    return universe.isEditable();
  }
}
