// File Score.java

package jvpc.vga;

import java.io.*;

/**
 * A set of scores, suitable for graphical display, as soon as the history is
 * kept stored somewhere.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     24 II 1999
 * @version   19 II 2001
 */
public class Score 
    implements VGAPlanets
{
    public int planets,capitals,freighters,bases;
  
    public Score() {}

    public void readGenScore(LSBReader source) throws IOException {
	planets=source.readShort();
	capitals=source.readShort();
	freighters=source.readShort();
	bases=source.readShort();
    }

    public int getPlanets() {
	return planets;
    }

    public int getCapitals() {
	return capitals;
    }

    public int getFreighters() {
	return freighters;
    }

    public int getBases() {
	return bases;
    }

    public int getTotal() {
	return 10*planets + 120*bases + 10*capitals + freighters;
    }

    public void writeGenScore(LSBWriter sink) throws IOException {
	sink.writeShort(planets);
	sink.writeShort(capitals);
	sink.writeShort(freighters);
	sink.writeShort(bases);
    }
}
