// File: ShipXYGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates <CODE>ShipXY</code> objects.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     24 II 1999
 * @version   9 I 2000
 */
public class ShipXYGen extends Generator {
  /**
   * Constructs an ShipXY generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public ShipXYGen(InputStream is) throws IOException {
    super(is);
  }

  public ShipXYGen(Generator g) throws IOException {
    super(g);
  }

  /**
   * Generates all <CODE>ShipXY</code> objects found in <CODE>pis</code>.
   * Puts them at the proper place in <CODE>ship[]</code>
   */
  public void generateAll(Universe u, int player) {
    int id;
    Ship target;
    for (id=1;id<=ships;id++) {
      try {
	if (u.containsShip(id)) {
	  target=u.getShip(id);
	  if (target!=null) {
	    // We have a ship; read shipxy -- info should match
	    target.readShipxyFrom(source, player);
	  }
	} else {
	  target=new Ship(u,id);
	  target.readShipxyFrom(source, player);
	  if (target.getOwner()!=UNKNOWN) u.putShip(target);
	}
      } catch (IOException ioe) {
	crash(11, "Error while reading shipdata: "+ioe);
      }
    }
  }
}
