// File: TargetGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates <CODE>Target</code> objects.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     22 XII 1998
 * @version   9 II 2001
 */
public class TargetGen
  extends Generator
{
  /**
   * Constructs an Target generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public TargetGen(InputStream is) throws IOException {
    super(is);
  }

  public TargetGen(Generator g) throws IOException {
    super(g);
  }

  public void setInfile(InputStream is) {
    source=new LSBReader(is);
  }

  /**
   * Generates all <CODE>Target</code> objects found in <CODE>pis</code>.
   * Puts them at the proper place in <CODE>ship[]</code>
   */
  public void generateAll(Universe u,int player) {
    int i,id;
    Ship ship;
    try {
      int targetcount=source.readShort();
      for (i=1;i<=targetcount;i++) {
	id=source.readShort();
	if (u.containsShip(id)) {
	  // target is DIS data, can't have edited; not read for DAT anymore
	  ship=u.getShip(id);
	} else {
	  ship=new Ship(u,id);
	  u.putShip(ship);
	}
	ship.readTargetFrom(source,player);
      }
    } catch (IOException ioe) {
      crash(11, "Error while reading shipdata: "+ioe);
    }
  }
}
