// File: ToPlanet.java

package jvpc.vga;

import java.io.*;
import kero.util.*;

/**
 * Ships to-planet version of a Planet. Cute for the GUI, a pain in the ass due
 * to the data-structures (really Tim, this part s*cks).
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     29 I 2000
 * @version   14 III 2000
 */
public class ToPlanet
  extends CargoTransfer
  implements VGAPlanets, CargoTransferable
{
  Ship ship;    // ship we are tranfering from
  int planetid; // id of planet we are transfering to

  public ToPlanet(Ship ship) {
    super(ship.universe);
    this.ship = ship;
    planetid = 0;
  }

  public Object clone() throws CloneNotSupportedException {
    return super.clone();
  }

  public void readFrom(LSBReader source) throws IOException {
    cargo[Cargo.NEUTRONIUM].amount = source.readShort();
    cargo[Cargo.TRITANIUM].amount = source.readShort();
    cargo[Cargo.DURANIUM].amount = source.readShort();
    cargo[Cargo.MOLYBDENIUM].amount = source.readShort();
    cargo[Cargo.COLCLANS].amount = source.readShort();
    cargo[Cargo.SUPPLIES].amount = source.readShort();
    planetid = source.readShort();

    // now there are two uninitialized fields left (can't transfer to them)
    cargo[Cargo.MC].amount = 0;
    cargo[Cargo.AMMUNITION].amount = 0;
  }

  public void writeTo(LSBWriter sink) throws IOException {
    sink.writeShort(getNeutronium());
    sink.writeShort(getTritanium());
    sink.writeShort(getDuranium());
    sink.writeShort(getMolybdenium());
    sink.writeShort(getColClans());
    sink.writeShort(getSupplies());
    sink.writeShort(planetid);
  }

    public void throwEvent() {
	// actually an event of the ship that the cargo comes from.
	// do nothing.
    }

  public int getOwner() {
    Planet planet = ship.getUniverse().getPlanet(planetid);
    if (planet == null) return 0;
    return planet.getOwner();
  }

  private void setPlanetId() {
    Planet planet = ship.getLocation().getPlanet();
    if (planet != null) planetid = planet.getId();
  }

  public void setCargo(int cargotype, int newamount) {
    Assert.assert(cargotype != Cargo.MC); // can't transfer MC to planet!
    Assert.assert(cargotype != Cargo.AMMUNITION); // can't transfer ammo either
    if (cargo[cargotype].amount == newamount) return;
    cargo[cargotype].amount = newamount;
    setPlanetId();
    // if (throwEvent) ship.getUniverse().throwShipEvent(ship.getId());
  }

  public int maxCargo(int cargotype) {
    return INFINITY;
  }

  public void transferCargoTo(CargoTransferable partner,
			      int cargotype, int newamount) {
    Assert.assert(false);
  }
}
