// File: ToShip.java

package jvpc.vga;

import java.io.*;
import kero.util.*;

/**
 * Ships to-ship version of a Ship. Cute for the GUI, a pain in the ass due
 * to the data-structures (really Tim, this part s*cks).
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     29 I 2000
 * @version   14 III 2000
 */
public class ToShip
  extends CargoTransfer
  implements VGAPlanets, CargoTransferable
{
  Ship ship;    // ship we are tranfering from
  int shipid; // id of ship we are transfering to

  public ToShip(Ship ship) {
    super(ship.universe);
    this.ship = ship;
    shipid = 0;
  }

  public Object clone() throws CloneNotSupportedException {
    return super.clone();
  }

  public void readFrom(LSBReader source) throws IOException {
    // order matches VPA :)
    cargo[Cargo.NEUTRONIUM].amount = source.readShort();
    cargo[Cargo.TRITANIUM].amount = source.readShort();
    cargo[Cargo.DURANIUM].amount = source.readShort();
    cargo[Cargo.MOLYBDENIUM].amount = source.readShort();
    cargo[Cargo.COLCLANS].amount = source.readShort();
    cargo[Cargo.SUPPLIES].amount = source.readShort();
    shipid = source.readShort();
    
    // now there are two uninitialized fields left (can't transfer to them)
    cargo[Cargo.MC].amount = 0;
    cargo[Cargo.AMMUNITION].amount = 0;
  }

  public void writeTo(LSBWriter sink) throws IOException {
    sink.writeShort(getNeutronium());
    sink.writeShort(getTritanium());
    sink.writeShort(getDuranium());
    sink.writeShort(getMolybdenium());
    sink.writeShort(getColClans());
    sink.writeShort(getSupplies());
    sink.writeShort(shipid);
  }

    public void throwEvent() {
	// actually an event of the ship that the cargo comes from.
	// do nothing.
    }

  public int getOwner() {
    Ship sh = ship.getUniverse().getShip(shipid);
    if (sh == null) return UNKNOWN;
    return sh.getOwner();
  }

  public int getShipId() {
    return shipid;
  }

  public void setShipId(int id) {
    Ship sh = ship.getUniverse().getShip(id);
    if (sh != null) {
      Assert.assert(sh.getOwner() != ship.getOwner());
      System.err.println("Ship["+ship.getId()+"].toship.id = "+shipid);
      shipid = id;
    } else {
	System.err.println("HELP SHIP NOT FOUND");
    }
  }

  public void setCargo(int cargotype, int newamount) {
    Assert.assert(cargotype != Cargo.MC); // use 'btm' instead
    Assert.assert(cargotype != Cargo.AMMUNITION); // use 'btt' or 'btf' instead
    if (cargo[cargotype].amount == newamount) return;
    cargo[cargotype].amount = newamount;
    // setShipId();  // Now this *has* to be done before !
    // if (throwEvent) ship.getUniverse().throwShipEvent(ship.getId());
  }

  public int maxCargo(int cargotype) {
    return INFINITY;
  }

  public void transferCargoTo(CargoTransferable partner,
			      int cargotype, int newamount) {
    Assert.assert(false);
  }
}
