// File: Torpedo.java

package jvpc.vga;

import java.io.*;

/**
 * One torpedo from TORPSPEC.DAT
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     24 I 1999
 * @version   29 XII 2000
 */
public class Torpedo
    implements VGAPlanets
{
    protected String name, shortname;
    protected int unitmc;              // costs of one torpedo
    protected int mc,trit,dur,molyb;   // costs of the launcher
    protected int mass,tech,kill,expl;

    public Torpedo() {}

    public void readFrom(LSBReader source) throws IOException {
	name=source.readString(TORPNMSIZE).toString();
	shortname=name.substring(0,name.indexOf(' '));
	unitmc=source.readShort();
	mc=source.readShort();
	trit=source.readShort();
	dur=source.readShort();
	molyb=source.readShort();
	mass=source.readShort();
	tech=source.readShort();
	kill=source.readShort();
	expl=source.readShort();
    }

    public String getName() {
	return name;
    }

    public String getShortName() {
	return shortname;
    }

    public int getMass() {
	return mass;
    }

    public int getTech() {
	return tech;
    }

    public int getUnitCost() {
	return unitmc;
    }
}
