// File: TorpedoGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates Torpedos from the file "torpspec.dat".
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     24 I 1999
 * @version   21 XII 1999
 */
public class TorpedoGen extends Generator {
  /**
   * Constructs a Torpedo generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public TorpedoGen(InputStream is) throws IOException {
    super(is);
  }

  /**
   * Generates 10 <CODE>Torpedo</code> objects.
   */
  public void generateAll(Game game) {
    for (int i=1; i<=torpedoes; i++) {
      Torpedo torpedo = new Torpedo();
      try {
	torpedo.readFrom(source);
	game.torpedo[i] = torpedo; // hack...
      } catch (IOException ioe) {
	crash(11, "Error while reading torpspec.dat: "+ioe);
      }
    }
  }
}
