// File: TruehullGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates Truehulls from the file "truehull.dat".
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     25 II 1999
 * @version   21 XII 1999
 */
public class TruehullGen extends Generator {
  /**
   * Constructs a Truehull generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public TruehullGen(InputStream is) throws IOException {
    super(is);
  }

  /**
   * Generates all <CODE>Truehull</code> objects.
   */
  public void generateAll(Game game) {
    for (int i=1; i<=races; i++) {
      Truehull truehull=new Truehull();
      try {
	truehull.readFrom(source);
	game.truehull[i] = truehull;
      } catch (IOException ioe) {
	crash(11, "Error while reading truehull.dat: "+ioe);
      }
    }
  }
}
