// File: VGAPlanets.java

package jvpc.vga;

import java.io.*;

/**
 * Defines global constants.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     10 VII 1998
 * @version   22 X 2000
 */
public interface VGAPlanets
    extends Cloneable
{
    // amounts of various objects
    public static final int players=11;
    public static final int races=11;
    public static final int planets=500;
    public static final int ships=500;
    public static final int wormholes=100;
    public static final int hulls=105;     // total number of hulls
    public static final int hullfunctions=20; // funcs from (phost3) HULLFUNC
    public static final int buildhulls=20; // #hulls that can be built on bases
    public static final int engines=9;
    public static final int torpedoes=10;
    public static final int beams=10;

    // lengths of various Strings
    public static final int TIMESTAMPSIZE=18;
    public static final int PWDSIZE=10;
    public static final int HULLNMSIZE=30;
    public static final int ENGNMSIZE=20;
    public static final int TORPNMSIZE=20;
    public static final int BEAMNMSIZE=20;
    public static final int PLANETNMSIZE=20;
    public static final int RACELONGSIZE=30;
    public static final int RACESHORTSIZE=20;
    public static final int RACEADJSIZE=12;
    public static final int FCSIZE=3;
    public static final int SHIPNMSIZE=20;

    // lengths of various Tim data structures (in file)
    public static final int DUMMYINXYPLAN=2;
    public static final int SHIPXYSIZE=8;
    public static final int TARGETSIZE=14+SHIPNMSIZE;
    public static final int FIZZSIZE=204;

    // some dubious offsets Tim uses
    public static final int MESSCODE=13;
    public static final int FIZZSHIP=667;
    public static final int FIZZPLAN=1667;
    public static final int FIZZBASE=1262;

    // some limits
    public static final int maxWarp=9;
    public static final int maxMcOnship=10000;

    // other useful numbers
    public static final int UNKNOWN=-153627;
    public static final int TRUE=-394398;
    public static final int FALSE=-893451;
    public static final int NONE=0;
    public static final int ALL=-982345;
    public static final int ILLEGAL=-520944;
    public static final int INFINITY=-426820;

    // hashtable prefixes
    public static final String planethashprefix="P";
    public static final String basehashprefix="B";
    public static final String shiphashprefix="S";
    public static final String vcrhashprefix="V";
    public static final String genhashprefix="Gen";
    public static final String explosionhashprefix="Expl";
    public static final String ionstormhashprefix="Ion";
    public static final String wormholehashprefix="W";
    public static final String minefieldhashprefix="M";

    // tech level stuff
    public static final int engineTech = 0;
    public static final int hullTech = 1;
    public static final int beamTech = 2;
    public static final int torpedoTech = 3;
    public static final int nrOfTechLevels = 4;
    public static final int maxTechLevel = 10;
    public static final int[] totalTechLevelCost = {
	0, 0, 100, 300, 600, 1000, 1500, 2100, 2800, 3600, 4500
    };
    
    // PHost vcr values
    public static final int vcrvictory=0;
    public static final int vcrcaptured=1;
    public static final int vcrdestroyed=2;
    public static final int vcrnoammo=3;

    // PHost Hullfunc values
    public static final int funcalchemy = 0;
    public static final int funcrefinery = 1;
    public static final int funcadvancedrefinery = 2;
    public static final int funcheatsto50 = 3;
    public static final int funccoolsto50 = 4;
    public static final int funcheatsto100 = 5;
    public static final int funchyperjump = 6;
    public static final int funcgravitonic = 7;
    public static final int funcwormholescan = 8;
    public static final int funcgamble = 9;
    public static final int funcdecloak = 10;
    public static final int funcassault = 11;
    public static final int funcchunnel = 12;
    public static final int funcfuelscoop = 13;
    public static final int funcbioscan100 = 14;
    public static final int funcadvancedcloak = 15;
    public static final int funccloak = 16;
    public static final int funcbioscan20 = 17;
    public static final int funcglory10 = 18;
    public static final int funcglory20 = 19;
}
