// File: VcrGen.java

package jvpc.vga;

import java.util.Hashtable;
import java.io.*;

/**
 * Generates <CODE>Vcr</code> objects.
 *
 * @author    Kero van Gelder
 * @copyright Kero van Gelder (the GNU General Public License applies)
 * @since     22 XII 1998
 * @version   21 XII 1999
 */
public class VcrGen extends Generator {
  private int vcrcount;

  /**
   * Constructs an Vcr generator.
   * @param is The <CODE>InputStream</code> from which the <CODE>source</code>
   * can be created.
   */
  public VcrGen(InputStream is) throws IOException {
    super(is);
    vcrcount=source.readShort();
  }

  public VcrGen(Generator g) throws IOException {
    super(g);
    vcrcount=source.readShort();
  }

  /**
   * Generates all <CODE>Vcr</code> objects found in <CODE>pis</code>.
   * Puts them at the proper place in <CODE>ship[]</code>
   */
  public void generateAll(Universe u) {
    int i,id;
    Ship ship;
    Vcr vcr;
    for (i=1;i<=vcrcount;i++) {
      try {
	vcr=new Vcr(u);
	vcr.readFrom(source);
	u.putVcr(vcr); // universe does the necessary filtering
      } catch (IOException ioe) {
	crash(11, "Error while reading shipdata: "+ioe);
      }
    }
  }
}
