// File: ActionPlanetFCRandom

package jvpc.vpcheck;

import java.util.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * @author    Rutger Nijlunsing
 * @copyright Rutger Nijlunsing (the GNU General Public License applies)
 * @version   19 XII 1999
 */
public class ActionPlanetFCRandom extends Action {
  
  private char getRandomChar() {
    String chars =
      "0123456789" + 
      "abcdefghijklmnopqrstuvwxyz" +
      "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    return chars.charAt(Mymath.random(chars.length()));
  }

  /** 
   * Sets the FC of a planet to a random planet code
   * whenever a FC is not a special FC for a planet.
   */
  public boolean action(Vector objects, Vector args, StringBuffer msg) {
    Assert.assert(objects.size() == 1);
    msg.setLength(0);
    
    if (!(objects.elementAt(0) instanceof PData))
	return false;
    PData p = (PData)objects.elementAt(0);
    int owner=p.getOwner();
    if ((owner==UNKNOWN) || (owner==0)) return false;

    String fc = p.getFC();

    if (!FC.isPlanetSpecial(fc)) {
	boolean special;
	String newfc;

	do {
	    newfc = "" + getRandomChar() + getRandomChar() + getRandomChar();
	    special = FC.isPlanetSpecial(newfc) ||
		FC.isAlmostPlanetSpecial(newfc) ||
		FC.isShipSpecial(newfc);
	} while (special);

	p.setFC(newfc);
	addToMsg(msg, "does not have a special FC");
	addToMsg(msg, "set FC to '" + newfc + "'");
	return true;
    }

    return false;
  }
}


