// File: ActionShipFCClear

package jvpc.vpcheck;

import java.util.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * Clear a one-time fc's (like 'mkt') to 'WRS'
 */
public class ActionShipFCClear extends Action {
  
  public boolean action(Vector objects, Vector args, StringBuffer msg) {
    String ones[] = {
	"HYP", "WRT", "bdm", "cln", "mkt", "mdh", "mdq", "AAA", "BBB", "CCC",
	"DDD", "EEE", "FFF", "GGG", "HHH", "III", "JJJ", "KKK"
    };

    Assert.assert(objects.size() == 1);
    Assert.assert(args.size() == 0);
    Ship s = (Ship)objects.elementAt(0);
    String fc = s.getFC();

    msg.setLength(0);
    if (fc == null)
      return false;

    for (int i=0; i<ones.length; i++) {
      if (ones[i].equals(fc)) {
	addToMsg(msg, "setting FC from '" + fc + "' to 'WRS'");
	s.setFC(new String("WRS"));
	return true;
      }
    }

    return false;
  }
}
