// File: ActionShipMissionClear

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

/**
 * Clear a one-time mission (like mine laying, ...) to 'mine sweep'
 */
public class ActionShipMissionClear extends Action {
  
  public boolean action(Vector objects, Vector args, StringBuffer msg) {
    Assert.assert(objects.size() == 1);
    Assert.assert(args.size() == 0);
    Ship s = (Ship)objects.elementAt(0);
    int mission = s.getMission();
    msg.setLength(0);
    if (mission == UNKNOWN)
      return false;

    PConfig config = s.getConfig();

    if ((mission != Mission.EXPLORE) &&
	(mission != Mission.KILL) &&
	(mission != Mission.SENSORSWEEP) &&
	(mission != Mission.TOW) &&
	(mission != Mission.INTERCEPT) &&
	(mission != Mission.SPECIAL) &&
	(mission != Mission.CLOAK) &&
	(mission != Mission.standardSuperSpy(config)) &&
	(mission != Mission.cloak(config)) &&
	(mission != Mission.special(config)) &&
	(mission != Mission.MINESWEEP)) {
      if (s.getHull().canCloak()) {
	  s.setMission((s.getRaceOwner() == 3) ? Mission.SPECIAL : Mission.CLOAK);
	  addToMsg(msg, "setting mission from " + s.getGame().getMission(mission) + " to "+(s.getRaceOwner() == 3 ? "Super Spy" : "Cloak"));
      } else {
	s.setMission(Mission.MINESWEEP);
	addToMsg(msg, "setting mission from " + s.getGame().getMission(mission) + " to Minesweep");
      }
      return true;
    }

    return false;
  }
}
