// File: ActionShipNameClear

package jvpc.vpcheck;

import java.util.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * Clear a one-time fc's (like 'mkt') to 'WRS'
 */
public class ActionShipNameClear extends Action {
  
  public boolean action(Vector objects, Vector args, StringBuffer msg) {
    Assert.assert(objects.size() == 1);
    Assert.assert(args.size() == 0);
    Ship s = (Ship)objects.elementAt(0);

    msg.setLength(0);
    if (!s.isOurShip())
	return false;

    String name = s.getName();

    if (s.getHull().getName().startsWith(name)) {
	s.setName("Ship "+s.getId());
	addToMsg(msg, "setting name from default to 'Ship "+s.getId()+".");
	return true;
    }

    return false;
  }
}
