// File: ActionShipUnloadLadyRoyale

package jvpc.vpcheck;

import java.util.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * Clear a one-time fc's (like 'mkt') to 'WRS'
 */
public class ActionShipUnloadLadyRoyale extends Action {
  
  public boolean action(Vector objects, Vector args, StringBuffer msg) {
    Assert.assert(objects.size() == 1);
    Assert.assert(args.size() == 0);
    Ship s = (Ship)objects.elementAt(0);

    msg.setLength(0);
    if (!s.isOurShip() || !s.getHull().hasCasino() || (s.getMC() == 0))
	return false;

    Planet p = s.getLocation().getPlanet();
    if (!(p instanceof BData))
	return false;

    BData b = (BData)p;
    s.transferCargoTo((CargoTransferable)b, Cargo.MC, s.getMC());
    addToMsg(msg, "Dumping MC from Ship " + s.getId() + " to Base "+ b.getId());

    return true;
  }
}
