// File: VPCheck.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

abstract public class Check implements VGAPlanets {
  
  /**
   * Check objects in col.
   *
   * msg is changed to reflect the argumentation.
   * check returns true if the check was passed.
   */
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(false);	// This is an abstract method :)
    return false;
  }

  /**
   * Add postmsg to msg
   */
  public static void addToMsg(StringBuffer msg, String postmsg) {
    msg.append("    ");
    msg.append(postmsg);
    msg.append("\n");
  }


  /**
   * Add truemsg or falsemsg to msg, depending on whether the
   * check was true or false. 
   */
  public static boolean logCheck(boolean check, StringBuffer msg,
				 String truemsg, String falsemsg) {
    if (check) {
      addToMsg(msg, truemsg);
    } else {
      addToMsg(msg, falsemsg);
    }
    return(check);
  }

}
