// File: CheckPlanetDamage.java

package jvpc.vpcheck;

import jvpc.vga.*;
import kero.util.*;
import java.util.*;


/**
 * Checks whether a base has damage
 */
class CheckBaseDamage extends Check {
    public boolean check(Vector col, StringBuffer msg) {
	Assert.assert(col.size() == 1);
	Planet p = (Planet)col.elementAt(0);
	BData b = p.getBase();
	if (b == null) {
	    // No base
	    return false;
	}

	int damage = b.getDamage();
	if (damage > 0) {
	    addToMsg(msg, "Base has "+damage+" damage");
	    return true;
	}

	return false;
    }
}
