//File: CheckPlanetBaseBuilding.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;


/**
 * Checks whether a base around a planet is building a ship
 */
class CheckPlanetBaseBuilding extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    Planet p = (Planet)col.elementAt(0);
    BData b = p.getBase();
    if (b == null)		// No base
      return false;

    if (b.isBuildingShip() == FALSE) {
      addToMsg(msg, "Base is not building a ship");
      return true;
    }
    return false;
  }
}
