// File: CheckPlanetColTooMany.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

// Check whether there are too many colonists,
// which will die next turn

/**
 * @version   19 XII 1999
 */
class CheckPlanetColTooMany extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    msg.setLength(0);
    Planet p = (Planet)col.elementAt(0);
    int maxcol = p.getMaxClans();
    if (maxcol == UNKNOWN)
      return false;
    int nocol = p.getColClans();
    if (nocol == UNKNOWN)
      return false;

    boolean check = (nocol > maxcol);
    if (check) {
      addToMsg(msg, "supports only " + maxcol + " colonist clans, " +
	       "instead of " + nocol);
      return true;
    }

    return false;
  }
}
