// File: CheckPlanetFCbum.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

// Checks whether a planet with FC 'bum' succeeds

class CheckPlanetFCbum extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    msg.setLength(0);
    Planet p = (Planet)col.elementAt(0);

    if ("bum".equals(p.getFC())) {
      addToMsg(msg, "has FC 'bum'");
      if (p.getMC() == 0) {
	addToMsg(msg, "has no MCs");
	addToMsg(msg, "'bum' will not succeed");
	return true;
      }
    }

    return false;
  }
}
