// File: CheckPlanetFact.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

// Checks whether the planet has too little or too much factories

/**
 * @version   19 XII 1999
 */
class CheckPlanetFact extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    msg.setLength(0);
    Planet p = (Planet)col.elementAt(0);

    int fact = p.getFactories();
    if (fact == UNKNOWN)
      return false;

    int nocol = p.getColClans();
    if (nocol == UNKNOWN)
      return false;

    int supp = p.getSupplies();
    if (supp == UNKNOWN)
      return false;

    int mc = p.getMC();
    if (mc == UNKNOWN)
      return false;

    int max = p.getMaxFactories();
    addToMsg(msg, "can have " + max + " factories, " +
	     "and has " + fact + " factories");
    boolean check = (fact < max);
    if (check) {
      check = (supp > 0) && (supp + mc >= 4);
      logCheck(check, msg, "can build more factories",
	       "cannot build more factories");
      if (check)
	return true;
    }

    check = (fact > max);
    if (check) {
      addToMsg(msg, "some factories will be destroyed");
      return true;
    }
    return false;
  }
}
