// File: CheckPlanetMineralZero.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

// Check whether there is no mineral on an unowned
// planet, which indicates an passed ship [possibly enemy]

class CheckPlanetMineralZero extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    msg.setLength(0);
    Planet p = (Planet)col.elementAt(0);
    if (p.getOwner() == NONE) {
      // Unowned planet
      if ((p.getSurfNeutronium() == 0) ||
	  (p.getSurfTritanium() == 0) ||
	  (p.getSurfDuranium() == 0) ||
	  (p.getSurfMolybdenium() == 0)) {
	addToMsg(msg, "0 of some mineral on surface of unowned planet");
	return true;
      }
    }
     
    return false;
  }
}
