// File: CheckPlanetNatTax.java

package jvpc.vpcheck;

import java.util.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * Check whether the natives are not taxed
 * so that the unhappyness drops below 70
 * @version 15 XII 2000
 */
class CheckPlanetNatTax extends Check {
    public boolean check(Vector col, StringBuffer msg) {
	Assert.assert(col.size() == 1);
	msg.setLength(0);
	Planet p = (Planet)col.elementAt(0);

	int happy = p.getNatHappyNT();
	if (happy == UNKNOWN) return false;

	if ((happy < 70) && (p.getNatHappy() >= 70)) {
	    addToMsg(msg, "natives happyness drops to "+happy+" next turn");
	    return true;
	} else if (happy < 70) {
	    addToMsg(msg, "native happyness goes from "+p.getNatHappy()+
		     " to "+happy+" next turn");
	}

	return false;
    }
}
