// File: CheckPlanetTempTooHigh.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

// Check whether the temperature is low enoug for the clans

class CheckPlanetTempTooHigh extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    msg.setLength(0);
    Planet p = (Planet)col.elementAt(0);

    int temp = p.getTemp();
    if (temp == UNKNOWN)
      return false;
    int race = p.getRaceOwner();
    if (race == UNKNOWN)
      return false;

    boolean check = (temp > 84);
    logCheck(check, msg, "temperature is > 84", "temperature is <= 84");
    if (check) {
      check = ((race != Race.CRYSTALS) || (!p.getConfig().crystalsPreferDeserts()));
      logCheck(check, msg,
	       "owner are not the crystals",
	       "owner are the crystals");
      return check;
    }

    return false;
  }
}
