// File: CheckShipCrew.java

package jvpc.vpcheck;

import jvpc.vga.*;
import kero.util.*;
import java.util.*;


/**
 * Checks whether a ship has enough crew.
 */
class CheckShipCrew extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    Ship s = (Ship)col.elementAt(0);
    // msg.setLength(0);

    int crewcount = s.getCrew();
    if (crewcount > 0) { // != UNKNOWN???
	int hullcrewcount = s.getHull().getCrew();
	if (crewcount < hullcrewcount) {
	    addToMsg(msg, "ship has "+crewcount+" crew, instead of "+
		     hullcrewcount);
	    return true;
	}
    }

    return false;
  }
}
