// File: CheckShipFCSpecial.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;

/**
 * Checks for almost special friendly codes
 */
  
class CheckShipFCSpecial extends Check {
  public CheckShipFCSpecial() {}

  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    Ship s = (Ship)col.elementAt(0);
    String fc = s.getFC();

    boolean check = FC.isAlmostShipSpecial(fc);
    msg.setLength(0);
    addToMsg(msg, "FC '"+fc+"' is "+ (check ? "" : "not ") +
	     "almost a special FC");
    if (check)
      return true;

    check = FC.isPlanetSpecial(fc);
    msg.setLength(0);
    addToMsg(msg, "FC '"+fc+"' is "+ (check ? "" : "not ") +
	     "a special Planet FC");
    if (check)
      return true;

    check = FC.isAlmostPlanetSpecial(fc);
    msg.setLength(0);
    addToMsg(msg, "FC '"+fc+"' is "+ (check ? "" : "not ") +
	     "almost a special Planet FC");
    if (check)
      return true;

    return false;
  }
}
