//File: CheckShipFCWRT.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;


/**
 * Checks whether an attempted wormhole travel succeeds
 * Returns true when an error occurs.
 */
class CheckShipFCWRT extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    Ship s = (Ship)col.elementAt(0);
    msg.setLength(0);

    Universe u = s.getUniverse();
    MyPoint n = s.getPositionNT();
    if (n == null)
      return false;
    Location loc = u.getLocationAt(n.getXint(), n.getYint());
    // should be something like getWormholesAt()
    boolean wormhole = false;
    if (loc != null) wormhole = (loc.getWormholes().size() > 0);
    logCheck(wormhole, msg, "goes to a wormhole", "does not go to a wormhole");

    String fc = s.getFC();
    boolean checkfc = "WRT".equals(fc);
    if (logCheck(checkfc, msg, "has FC 'WRT'", "has not FC 'WRT'")) {
      if (wormhole) {
	return false;
      } else {
	addToMsg(msg, "ship will not travel through wormhole");
	return true;
      }
    } else {
      if (wormhole) {
	addToMsg(msg, "ship will not travel through wormhole");
	return true;
      } else {
	return false;
      }
    }
  }
}
