// File: CheckShipFCbdm.java

package jvpc.vpcheck;

import java.util.*;
import kero.util.*;
import jvpc.vga.*;

class CheckShipFCbdm extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    msg.setLength(0);
    Ship s = (Ship)col.elementAt(0);
    String fc = s.getFC();
    boolean check = "bdm".equals(fc);
    if (logCheck(check, msg, "has FC 'bdm'", "has not FC 'bdm'")) {
      int mc = s.getMC();
      if (mc == UNKNOWN)
	return false;
      check = (mc == 0);
      if (logCheck(check, msg, "has no MCs", "has >0 MCs")) {
	addToMsg(msg, "FC 'bdm' has no effect");
	return true;
      }
      Universe u = s.getUniverse();
      Location loc = u.getLocationAt(s.getX(), s.getY());
      check = loc.getPlanet () == null;
      logCheck(check, msg, "not at a planet", "at a planet");
      if (check) {
	return true;
      }
    }
    return false;
  }
}
