//File: CheckShipFCmkt.java

package jvpc.vpcheck; import jvpc.vga.*; import kero.util.*;

import java.util.*;


/**
 * Checks whether a ship with mission 'mkt' succeeds
 */
  
class CheckShipFCmkt extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    Ship s = (Ship)col.elementAt(0);
    msg.setLength(0);

    if ("mkt".equals(s.getFC())) {
      addToMsg(msg, "has FC 'mkt'");
      if (s.getMission() == Mission.scoopTorps(s.getConfig())) {
	addToMsg(msg, "has mission set to scoop: error prone");
	return true;
      }
      if (s.getTotalTritanium() == 0) {
	addToMsg(msg, "has 0 tritanium");
	return true;
      }
      if (s.getTotalDuranium() == 0) {
	addToMsg(msg, "has 0 duranium");
	return true;
      }
      if (s.getTotalMolybdenium() == 0) {
	addToMsg(msg, "has 0 molybdenium");
	return true;
      }
      if (s.getMC() == 0) {
	addToMsg(msg, "has 0 MCs");
	return true;
      }
    }

    return false;
  }
}
