// File: CheckShipMissionLayMines.java

package jvpc.vpcheck;

import jvpc.vga.*;
import java.util.*;
import kero.util.*;

/**
 * Checks whether a ship does a succesfull lay mines
 */
class CheckShipMissionLayMines extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    Ship s = (Ship)col.elementAt(0);
    msg.setLength(0);

    int mission = s.getMission();
    if (mission == UNKNOWN) return false;
    int torps = s.getTorpedoes();
    if (torps == UNKNOWN) return false;

    if (torps == 0) {
	addToMsg(msg, "has no torps");
	if (Mission.missionLaysMines(mission, s.getConfig(), s.getOwner())) {
	    addToMsg(msg, "but tries to lay (web) mines");
	    return true;
	}
    }

    return false;
  }
}
