// File: CheckShipMissionSet.java

package jvpc.vpcheck;

import jvpc.vga.*;
import kero.util.*;
import java.util.*;


/**
 * Checks whether a ship has a mission set.
 */
class CheckShipMissionSet extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    Ship s = (Ship)col.elementAt(0);
    // msg.setLength(0);

    if (s.getMission() == Mission.NONE) {
      addToMsg(msg, "ship has no mission set");
      return true;
    }

    if (s.getMission() == Mission.EXPLORE) {
      addToMsg(msg, "ship has mission explore");
      addToMsg(msg, "Use sensor sweep instead");
      return true;
    }

    return false;
  }
}
