// File: CheckShipNeutrZero.java

package jvpc.vpcheck;

import java.util.*;
import kero.util.*;
import jvpc.vga.*;

/**
 * Checks for no neutronium on board
 */
class CheckShipNeutrZero extends Check {
  public boolean check(Vector col, StringBuffer msg) {
    Assert.assert(col.size() == 1);
    msg.setLength(0);
    Ship s = (Ship)col.elementAt(0);

    boolean check = (s.getTotalNeutronium() == 0);

    if (check) {
      addToMsg(msg, "has 0 neutronium");
      return true;
    }

    int newNeutr = s.getNeutrAtWaypoint();
    if (newNeutr == UNKNOWN)
      return false;

    if (s.getNeutrAtWaypoint() <= 0) {
      addToMsg(msg, "will be out of fuel before it reaches its waypoint");
      return true;
    }

    return false;
  }
}
